
Const = {
	alNone          = 0,
	alTop           = 1,
	alBottom        = 2,
	alLeft          = 3,
	alRight         = 4,
	alClient        = 5,
	alCustom        = 6,
	bvNone          = 0,
	bvLowered       = 1,
	bvRaised        = 2,
	bvSpace         = 3,
	bsNone          = 0,
	bsSingle        = 1,
	bsSizeable      = 2,
	bsDialog        = 3,
	bsToolWindow    = 4,
	bsSizeToolWin   = 5,
	poDefault       = 1,
	poScreenCenter  = 4,
	poDesktopCenter = 5,
	clBlack         = 00000000,
	clMaroon        = 00000128,
	clGreen         = 00032768,
	clOlive         = 00032896,
	clNavy          = 08388608,
	clPurple        = 08388736,
	clTeal          = 08421376,
	clGray          = 08421504,
	clSilver        = 12632256,
	clRed           = 00000255,
	clLime          = 00065280,
	clYellow        = 00065535,
	clBlue          = 16711680,
	clFuchsia       = 16711935,
	clAqua          = 16776960,
	clWhite         = 16777215,
	sbHorizontal    = 0,
	sbVertical      = 1,
	wsNormal	= 0,
	wsMinimized	= 1,
}

------------------------------------------------

Menu = {
	{"Control",00,{
		{"Load"  ,10},
		{"Run"   ,11},
		{"-"     ,00},
		{"Lock"  ,12},
		{"Output",13},
		{"Unlock",14},
		{"-"     ,00},
		{"Exit"  ,15},
	}},
	{"Help",00,{
		{"About",21},
	}},
}

------------------------------------------------

MenuHandler = {
	[10] = function() LoadScript("script1.lua") end,
	[11] = function()
		Ctrl.SetScript(0,ScriptMemo.Lines.Text)
		Ctrl.SetState(0,1)
	end,
	[12] = function() Ctrl.Lock(0) end,
	[13] = function()
		if Ctrl.IsLocked(0) then
			local s = Ctrl.GetOutput(0)
			if s=="" then
				showmsg("Nothing in output!")
			else
				showmsg(s)
			end
		else
			showmsg("You shouldn't access Output while Instance is unlocked!")
		end
	end,
	[14] = function() Ctrl.Unlock(0) end,
	[15] = function() Obj.Exit() end,
	[21] = function() showmsg("OpenEUO v0.9c by Cheffe") end,
}

------------------------------------------------

function BuildMenu(parent,menu)
	if not menu then
		return
	end
	local f = function(s)
		if MenuHandler[s.Tag] then
			MenuHandler[s.Tag]()
		end
	end
	for i = 1,#menu do
		local t = menu[i]
		local m = Obj.Create("TMenuItem")
		m.Caption = t[1]
		m.Tag = t[2]
		m.OnClick = f
		BuildMenu(m,t[3])
		parent.Add(m)
	end
end

------------------------------------------------

function LoadScript(name)
	local f = openfile(name)
	local s = f:read("*a")
	f:close()
	ScriptMemo.Lines.Text = s
end 

------------------------------------------------

MainForm = Obj.Create("TForm")
MainForm.Font._ = {
	Name = "Courier New",
	Size = 10
}
MainForm._ = {
	Width = 600,
	Height = 350,
	Caption = "OpenEUO 0.9c",
	Position = Const.poScreenCenter,
	OnClose = function() Obj.Exit() end,
	Menu = Obj.Create("TMainMenu")
}
MainForm.Visible = true
BuildMenu(MainForm.Menu.Items,Menu)

ScriptMemo = Obj.Create("TMemo")
ScriptMemo.Align = Const.alClient
ScriptMemo.WantTabs = true
ScriptMemo.Parent = MainForm

if Ctrl.GetCount()==0 then
	Ctrl.Open()
end

Obj.Loop()

Ctrl.Close(0)
Obj.Free(ScriptMemo)
Obj.Free(MainForm)
